<?xml version="1.0" encoding="UTF-8"?>
<ruleset name="PMD Settings"
         xmlns="http://pmd.sourceforge.net/ruleset/2.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://pmd.sourceforge.net/ruleset/2.0.0 https://pmd.sourceforge.io/ruleset_2_0_0.xsd">
    <description/>

    <exclude-pattern>.*/generated/.*</exclude-pattern>
    <exclude-pattern>.*/test/.*</exclude-pattern>

    <rule ref="category/java/codestyle.xml">
        <exclude name="AbstractNaming"/>
        <exclude name="LongVariable"/>
        <exclude name="ShortClassName"/>
        <exclude name="ShortMethodName"/>
        <exclude name="ShortVariable"/>
        <exclude name="VariableNamingConventions"/>
        <exclude name="MethodArgumentCouldBeFinal"/>
        <exclude name="LocalVariableCouldBeFinal"/>
        <exclude name="AtLeastOneConstructor"/>
        <exclude name="OnlyOneReturn"/>
    </rule>

    <rule ref="category/java/bestpractices.xml">
        <exclude name="PreserveStackTrace"/>
    </rule>
    <rule ref="category/java/performance.xml"/>
    <rule ref="category/java/multithreading.xml"/>
    <rule ref="category/java/design.xml">
        <!-- So that it won't complain about DTO/Entity classes -->
        <exclude name="DataClass"/>
        <exclude name="TooManyFields"/>
        <!-- to be discussed -->
        <exclude name="LawOfDemeter"/>
    </rule>

    <rule ref="category/java/design.xml/UseUtilityClass">
        <properties>
            <!--Ignore UseUtilityClass on main application class-->
            <property name="violationSuppressXPath" value="//ClassOrInterfaceDeclaration['.*Application']"/>
        </properties>
    </rule>

    <rule ref="category/java/errorprone.xml">
        <!-- to be discussed -->
        <exclude name="BeanMembersShouldSerialize"/>
        <!-- wants to create getters/setters for all non static non transient fields
        ; nb. disabling it this way seems not to work -->
    </rule>

    <rule ref="category/java/errorprone.xml/AvoidDuplicateLiterals">
        <properties>
            <property name="skipAnnotations" value="true"/>
        </properties>
    </rule>

</ruleset>
